#Quota Script v3.61
#Put a line in your eggdrop.conf that says "source quotascript.tcl"
#IF YOU ARE UPGRADING FROM A VERSION OLDER THAN 3.0, DELETE YOUR OLD USERFILES!
#Use !yourcommand help for help on using. 

proc u {} {return };	# underline code
proc r {} {return };	# reverse code
proc b {} {return };	# bold code
proc c {} {return };	# color code
proc cc {} {return 4};	# you can put the color of the site output here too
proc o {} {return };	# reset attributes code

set Quota(dir) "users" ; #this is the directory that should be made allready to hold user files.

set Quota(MB) "2500"       ; #amount in MB users must upload

set Quota(days) "30"       ; #number of days they have to do it

set Quota(chan) "halcy0n"   ; #channel to report to

set Quota(RaidenUserFile) "C:/RaidenFTPD/default.user"    ; #path to raidenftpd user file make sure you use / instead of \

#When someone fails, what do you want it to do? 0 -> delete them, 1-> disable them, 2-> do nothing
set Quota(onfail) "1"

set Quota(exempt) [list "Admin" "friends" "siteops"]  ;#groups not accountable for uploading every month  
set Quota(showexempt) 1 		;# if this is set to 1 the exempted groups stats are shown (they still are exempt though)

set Quota(stem) "!vigquota"  ;#command to trigger the script

set Quota(color) "4"         ;#color of the output (0-15)

set Quota(sitename) "Vigilance"    ;#name of the site

set Quota(baseoutput) "[cc]([c][b]$Quota(sitename)[b][cc])[c]"  ;#the base of all output to the channel. 
								;# the default would return (sitename) with some colors and shit.

bind pub - [set Quota(stem)] QuotaSwitch
bind time - "00 06 * * *" QuotaCompile ;# 6:00 am
bind time - "00 12 * * *" QuotaCompile ;# 12:00 pm
bind time - "00 18 * * *" QuotaCompile ;# 6:00 pm
bind time - "00 00 * * *" QuotaCompile ;# 12:00 am

proc QuotaCompile {minute hour day month year} {
QuotaCheckAll
}

proc QuotaSwitch {nick uhost hand chan args} {
putlog "QuotaSwitch was sent $args"
    switch $args {
	script { QuotaAdvertise }
	help { QuotaHelp }
	recompile { QuotaCheckAll }
	default { QuotaCheckUser $args }
     }
}

proc QuotaHelp {} {
global Quota
putserv "PRIVMSG $Quota(chan) :[b]Quotascript help-[b] To (re)compile the database by hand use [cc][b]$Quota(stem) recompile"
putserv "PRIVMSG $Quota(chan) :To view specific account status use [cc][b]$Quota(stem) (username)"
putserv "PRIVMSG $Quota(chan) :To view script version use [cc][b]$Quota(stem) script"
return 0
}

proc QuotaCheckAll {} {
global Quota
putlog "QuotaCheckAll"
 set fileid [open $Quota(RaidenUserFile) r]
 set RaUserLine [split [read $fileid] \n]
 close $fileid
  foreach RaUser $RaUserLine {
    set RaUser [split $RaUser :]
    set QuotaUser [lindex $RaUser 0]
    set NewUP [lindex $RaUser 11]
	if {[info exists NewUP] && $NewUP != ""} {
	    set NewUP [expr $NewUP / 1024]
	} else {
	    set NewUP 0
        }
	if {![file exists $Quota(dir)/$QuotaUser.txt]} {
	   set now [clock seconds]
	   set fmt "%Y-%m-%d"
	   set now [clock format $now -format $fmt]
           set userfileid [open $Quota(dir)/$QuotaUser.txt a+]
	   puts $userfileid "$QuotaUser $now $NewUP"
	   close $userfileid
        }
    set QuotaGroup [lindex $RaUser 3]
    set oldinfo [split [OldInfo $QuotaUser] ]
    set OldUP [lindex $oldinfo 0]
	if {[info exists OldUP] && $OldUP != ""} {
	    set OldUP $OldUP
	} else {
	    set OldUP 0
        }
    set age [lindex $oldinfo 1]
    set QuotaResult [QuotaValid $QuotaUser $age $NewUP $OldUP $QuotaGroup]
  }
  putserv "PRIVMSG $Quota(chan) :Quota user database updated."
}

proc QuotaCheckUser {user} {
putlog "QuotaCheckUser was sent $user"
global Quota
 set fileid [open $Quota(RaidenUserFile) r]
 set RaUserLine [split [read $fileid] \n]
 close $fileid
  foreach RaUser $RaUserLine {
      set RaUser [split $RaUser :]
      if {[lindex $RaUser 0] == $user} {
	set NewUP [lindex $RaUser 11]
	if {[info exists NewUP] && $NewUP != ""} {
	    set NewUP [expr $NewUP / 1024]
	} else {
	    set NewUP 0
        }
	set oldinfo [split [OldInfo $user] ]
	if {[lindex $oldinfo 0] == "deleted"} {
		putserv "PRIVMSG $Quota(chan) :$Quota(baseoutput) [b]$user[b] was deleted on [lindex $oldinfo 1]"
		return 0
	}
	set age [lindex $oldinfo 1]
	set OldUP [lindex $oldinfo 0]
        putlog $oldinfo
	if {[info exists OldUP] && $OldUP != ""} {
	    set OldUP $OldUP
	} else {
	    set OldUP 0
        }
        set QuotaGroup [lindex $RaUser 3]
	set UserResult [QuotaValid $user $age $NewUP $OldUP $QuotaGroup]
	set UserResult [split $UserResult ]
	switch [lindex $UserResult 0] {
		Failed {putserv "PRIVMSG $Quota(chan) :$Quota(baseoutput) [b]-[string toupper [lindex $UserResult 0]]- $user[b] only uploaded [b][lindex $UserResult 1]MB[b] of the [b]$Quota(MB)MB[b] required this month"}
		Passed {
  			if {$Quota(showexempt) == 1 && [lsearch $Quota(exempt) $QuotaGroup] != -1} {
				putserv "PRIVMSG $Quota(chan) :$Quota(baseoutput) [b]-EXEMPT- $user[b] is in affiliated group [b]$QuotaGroup[b]. Had that not been the case, then [b]$user[b] would have passed for uploading the required [b]$Quota(MB)MB[b] and another [b][lindex $UserResult 1]MB[b] to go with it! [cc]([c][b][lindex $UserResult 2] days left[b][cc])[c]"
				return
			}
		   putserv "PRIVMSG $Quota(chan) :$Quota(baseoutput) [b]-[string toupper [lindex $UserResult 0]]- $user[b] uploaded the required [b]$Quota(MB)MB[b] and another [b][lindex $UserResult 1]MB[b] to go with it! [cc]([c][b][lindex $UserResult 2] days left[b][cc])[c]"}
		Missing {
  			if {$Quota(showexempt) == 1 && [lsearch $Quota(exempt) $QuotaGroup] != -1} {
				putserv "PRIVMSG $Quota(chan) :$Quota(baseoutput) -EXEMPT- $user is in affiliated group $QuotaGroup. Had that not been the case, then $user would be missing [b][lindex $UserResult 1]MB[b] with [b][lindex $UserResult 2] days[b] remaining, which means another [b][expr [lindex $UserResult 1] / [lindex $UserResult 2]]MB[b] per day [cc]([c][b]$Quota(MB)MB[b][cc]/[c][b]$Quota(days)Day[b][cc])[c]."
				return
			}
			 putserv "PRIVMSG $Quota(chan) :$Quota(baseoutput) [b]-[string toupper [lindex $UserResult 0]]- $user[b] has [b][lindex $UserResult 2] days[b] to upload [b][lindex $UserResult 1]MB[b] [cc]([c][b]$Quota(MB)MB[b][cc]/[c][b]$Quota(days)Day[b][cc])[c]"}
		Exempt {
		   putserv "PRIVMSG $Quota(chan) :$Quota(baseoutput) [b]-[string toupper [lindex $UserResult 0]]-[b] $user[b]@$QuotaGroup [b] is exempt from the monthly requirement."}
	
	}
      }
   }
unset NewUP 
unset OldUP
unset oldinfo
unset QuotaGroup
unset UserResult
unset age
}

proc QuotaValid {user age NewUP OldUP QuotaGroup} {
global Quota
putlog "QuotaValid was sent $user $age $NewUP $OldUP $QuotaGroup"
	if {$OldUP == "deleted"} {
		putserv "PRIVMSG $Quota(chan) :$Quota(baseoutput) [b]$user[b] was deleted on $age"
		return 0
	}
 if {[lsearch $Quota(exempt) $QuotaGroup] == -1 || $Quota(showexempt) == 1} {
	set age [clock scan $age]
	set now [clock seconds]
	set TheUP [expr $NewUP - $OldUP]
	set days [expr [expr [expr [expr $now - $age] / 60] / 60] / 24]
	if {$days >= $Quota(days)} {
		if {$TheUP < $Quota(MB)} { QuotaFailed $user $TheUP
					  return "Failed [expr $Quota(MB) - $TheUP] $days"
		} elseif {$TheUP > $Quota(MB)} { QuotaReset $user $TheUP
		}
	} elseif {$days <= $Quota(days) && $TheUP > $Quota(MB)} {
		QuotaPassed $user [expr $TheUP - $Quota(MB)] [expr $Quota(days) - $days]
		return "Passed [expr $TheUP - $Quota(MB)] [expr $Quota(days) - $days]"
	} else { return "Missing [expr $Quota(MB) - $TheUP] [expr $Quota(days) - $days]"
	}
 }
 return "Exempt"
}
		
proc OldInfo {user} {
global Quota
putlog "OldInfo was sent $user"
   if {[file exists $Quota(dir)/$user.txt]} {
      set fileid [open $Quota(dir)/$user.txt r]
      set oldinfo [split [read $fileid] ]
      close $fileid
	if {[lindex $oldinfo 0] == "deleted"} {
	return "deleted [lindex $oldinfo 1]"
	}
      return "[lindex $oldinfo 2] [lindex $oldinfo 1]"
    }
  return 0
}

proc QuotaFailed {user theup} {
putlog "QuotaFailed was sent $user $theup"
global Quota
   switch $Quota(onfail) {
      0 { 
	set now [clock seconds]
	set fmt "%Y-%m-%d"
	set now [clock format $now -format $fmt]
	set fileid [open $Quota(dir)/$user.txt w]
	puts $fileid "deleted $now"
	close $fileid
	FTP::Quote site deluser $user
	putserv "PRIVMSG $Quota(chan) :$Quota(baseoutput) [b]-[string toupper [lindex $UserResult 0]]- $user[b] was deleted for failing to upload the required amount."
      } 1 {
	FTP::Quote site disable $user
	putserv "PRIVMSG $Quota(chan) :$Quota(baseoutput) [b]-[string toupper [lindex $UserResult 0]]- $user[b]'s account was suspended for failing to upload the required amount."
      } 2 {
	QuotaReset $user $theup
      }
   }
 return $Quota(onfail)
}

proc QuotaPassed {user theup days} {
putlog "Quotapassed was sent $user $theup $days"
if {$days == 0} {
QuotaReset $user $theup
}
	return 0
}

proc QuotaReset {user theup} {
putlog "QuotaReset was sent $user $theup"
global Quota
	set now [clock seconds]
	set fmt "%Y-%m-%d"
	set now [clock format $now -format $fmt]
	set fileid [open $Quota(dir)/$user.txt w]
	puts $fileid "$nick $now $theup"
putlog "QUOTA>>> $nick starts a new term."
	close $fileid
}

proc QuotaAdvertise {} {
global Quota
putserv "PRIVMSG $Quota(chan) :$Quota(baseoutput) is using [b][cc]halcy0n's quotascript v3.61 [cc] - http://halcy0n.no-ip.org"
return 0
}